import { ObservableInput, Observable, NextObserver, Subscription } from 'rxjs';
import { Ref } from 'vue-demi';

declare function from<T>(value: ObservableInput<T> | Ref<T>): Observable<T>;
declare function fromEvent<T extends HTMLElement>(value: Ref<T>, event: string): Observable<Event>;

declare function toObserver<T>(value: Ref<T>): NextObserver<T>;

declare function useObservable<H>(observable: Observable<H>): Readonly<Ref<H>>;

declare function useSubscription(subscription: Subscription): void;

export { from, fromEvent, toObserver, useObservable, useSubscription };
